/**
 * Piwik - Open source web analytics
 *
 * @link http://piwik.org
 * @license http://www.gnu.org/licenses/gpl-3.0.html Gpl v3 or later
 */

exports.getDashboards = function ()
{
    return [{"name":"Dashboard","widgets":[{"module":"VisitsSummary","action":"getEvolutionGraph"},{"module":"Live","action":"widget"},{"module":"VisitorInterest","action":"getNumberOfVisitsPerVisitDuration"},{"module":"CoreHome","action":"getPromoVideo"},{"module":"Referers","action":"getKeywords"},{"module":"Referers","action":"getWebsites"},{"module":"UserCountryMap","action":"visitorMap"},{"module":"UserSettings","action":"getBrowser"},{"module":"Referers","action":"getSearchEngines"},{"module":"VisitTime","action":"getVisitInformationPerServerTime"},{"module":"ExampleRssWidget","action":"rssPiwik"}]}];
};

exports.getReportMetadata = function ()
{
    return [{"category":"All Websites","name":"Single Website dashboard","module":"MultiSites","action":"getOne","dimension":"Website","metrics":{"nb_visits":"Visits","visits_evolution":"Visits Evolution","nb_actions":"Actions","actions_evolution":"Actions Evolution","nb_pageviews":"Pageviews","pageviews_evolution":"Pageviews Evolution","revenue":"Revenue","revenue_evolution":"Revenue Evolution","nb_conversions":"Conversions","nb_conversions_evolution":"Conversions Evolution","orders":"Ecommerce Orders","orders_evolution":"Ecommerce Orders Evolution","ecommerce_revenue":"Product Revenue","ecommerce_revenue_evolution":"Product Revenue Evolution"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"MultiSites_getOne"},{"category":"All Websites","name":"All Websites dashboard","module":"MultiSites","action":"getAll","dimension":"Website","metrics":{"nb_visits":"Visits","visits_evolution":"Visits Evolution","nb_actions":"Actions","actions_evolution":"Actions Evolution","nb_pageviews":"Pageviews","pageviews_evolution":"Pageviews Evolution","revenue":"Revenue","revenue_evolution":"Revenue Evolution","nb_conversions":"Conversions","nb_conversions_evolution":"Conversions Evolution","orders":"Ecommerce Orders","orders_evolution":"Ecommerce Orders Evolution","ecommerce_revenue":"Product Revenue","ecommerce_revenue_evolution":"Product Revenue Evolution"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"MultiSites_getAll"},{"category":"Visits Summary","name":"Visits Summary","module":"VisitsSummary","action":"get","metrics":{"nb_uniq_visitors":"Unique visitors","nb_visits":"Visits","nb_actions":"Actions","nb_actions_per_visit":"Actions per Visit","bounce_rate":"Bounce Rate","avg_time_on_site":"Avg. Visit Duration (in seconds)","max_actions":"Maximum actions in one visit"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitsSummary_get"},{"category":"Visits Summary","name":"Visits by Server Time","module":"VisitTime","action":"getVisitInformationPerServerTime","dimension":"Server time","documentation":"This graph shows what time it was in the <b> server's time zone <\/b> during the visits.","constantRowsCount":true,"metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"VisitTime_getVisitInformationPerServerTime"},{"category":"Visits Summary","name":"Visits by Local Time","module":"VisitTime","action":"getVisitInformationPerLocalTime","dimension":"Local time","documentation":"This graph shows what time it was in the <b> visitors' time zones <\/b> during their visits.","constantRowsCount":true,"metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitTime_getVisitInformationPerLocalTime"},{"category":"Visits Summary","name":"Visits by Day of Week","module":"VisitTime","action":"getByDayOfWeek","dimension":"Day of the week","documentation":"This graph shows the number of visits your website received on each day of the week.","constantRowsCount":true,"metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitTime_getByDayOfWeek"},{"category":"Actions","name":"Actions - Main metrics","module":"Actions","action":"get","metrics":{"nb_pageviews":"Pageviews","nb_uniq_pageviews":"Unique Pageviews","nb_downloads":"Downloads","nb_uniq_downloads":"Unique Downloads","nb_outlinks":"Outlinks","nb_uniq_outlinks":"Unique Outlinks","nb_searches":"Searches","nb_keywords":"Unique Keywords","avg_time_generation":"Avg. generation time"},"metricsDocumentation":{"nb_pageviews":"The number of times this page was visited.","nb_uniq_pageviews":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","nb_downloads":"The number of times this link was clicked.","nb_uniq_downloads":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_outlinks":"The number of times this link was clicked.","nb_uniq_outlinks":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_searches":"The number of visits that searched for this keyword on your website's search engine.","avg_time_generation":"The average time it took to generate the page. This metric includes the time it took the server to generate the web page, plus the time it took for the visitor to download the response from the server. A lower 'Avg. generation time' means a faster website for your visitors!"},"uniqueId":"Actions_get"},{"category":"Actions","name":"Page URLs","module":"Actions","action":"getPageUrls","dimension":"Page URL","metrics":{"nb_hits":"Pageviews","nb_visits":"Unique Pageviews","bounce_rate":"Bounce Rate","avg_time_on_page":"Avg. time on page","exit_rate":"Exit rate","avg_time_generation":"Avg. generation time"},"metricsDocumentation":{"nb_hits":"The number of times this page was visited.","nb_visits":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","bounce_rate":"The percentage of visits that started on this page and left the website straight away.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","exit_rate":"The percentage of visits that left the website after viewing this page.","avg_time_generation":"The average time it took to generate the page. This metric includes the time it took the server to generate the web page, plus the time it took for the visitor to download the response from the server. A lower 'Avg. generation time' means a faster website for your visitors!"},"documentation":"This report contains information about the page URLs that have been visited. <br \/> The table is organized hierarchically, the URLs are displayed as a folder structure.<br \/>Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getPageUrls","uniqueId":"Actions_getPageUrls"},{"category":"Actions","name":"Entry pages","module":"Actions","action":"getEntryPageUrls","dimension":"Page URL","metrics":{"entry_nb_visits":"Entrances","entry_bounce_count":"Bounces","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"entry_nb_visits":"Number of visits that started on this page.","entry_bounce_count":"Number of visits that started and ended on this page. This means that the visitor left the website after viewing only this page.","bounce_rate":"Percentage of visits that started and ended on this page."},"documentation":"This report contains information about the entry pages that were used during the specified period. An entry page is the first page that a user views during his visit. <br \/> The entry URLs are displayed as a folder structure. Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getEntryPageUrls","uniqueId":"Actions_getEntryPageUrls"},{"category":"Actions","name":"Exit pages","module":"Actions","action":"getExitPageUrls","dimension":"Page URL","metrics":{"exit_nb_visits":"Exits","nb_visits":"Unique Pageviews","exit_rate":"Exit rate"},"metricsDocumentation":{"exit_nb_visits":"Number of visits that ended on this page.","nb_visits":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","exit_rate":"The percentage of visits that left the website after viewing this page."},"documentation":"This report contains information about the exit pages that occurred during the specified period. An exit page is the last page that a user views during his visit. <br \/> The exit URLs are displayed as a folder structure. Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getExitPageUrls","uniqueId":"Actions_getExitPageUrls"},{"category":"Actions","name":"Page titles","module":"Actions","action":"getPageTitles","dimension":"Page Name","metrics":{"nb_hits":"Pageviews","nb_visits":"Unique Pageviews","bounce_rate":"Bounce Rate","avg_time_on_page":"Avg. time on page","exit_rate":"Exit rate","avg_time_generation":"Avg. generation time"},"metricsDocumentation":{"nb_hits":"The number of times this page was visited.","nb_visits":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","bounce_rate":"The percentage of visits that started on this page and left the website straight away.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","exit_rate":"The percentage of visits that left the website after viewing this page.","avg_time_generation":"The average time it took to generate the page. This metric includes the time it took the server to generate the web page, plus the time it took for the visitor to download the response from the server. A lower 'Avg. generation time' means a faster website for your visitors!"},"documentation":"This report contains information about the titles of the pages that have been visited. <br \/> The page title is the HTML &lt;title&gt; Tag that most browsers show in their window title.","actionToLoadSubTables":"getPageTitles","uniqueId":"Actions_getPageTitles"},{"category":"Actions","name":"Entry page titles","module":"Actions","action":"getEntryPageTitles","dimension":"Page Name","metrics":{"entry_nb_visits":"Entrances","entry_bounce_count":"Bounces","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"entry_nb_visits":"Number of visits that started on this page.","entry_bounce_count":"Number of visits that started and ended on this page. This means that the visitor left the website after viewing only this page.","bounce_rate":"Percentage of visits that started and ended on this page."},"documentation":"This report contains information about the titles of exit pages that occurred during the specified period. Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getEntryPageTitles","uniqueId":"Actions_getEntryPageTitles"},{"category":"Actions","name":"Exit page titles","module":"Actions","action":"getExitPageTitles","dimension":"Page Name","metrics":{"exit_nb_visits":"Exits","nb_visits":"Unique Pageviews","exit_rate":"Exit rate"},"metricsDocumentation":{"exit_nb_visits":"Number of visits that ended on this page.","nb_visits":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","exit_rate":"The percentage of visits that left the website after viewing this page."},"documentation":"This report contains information about the titles of entry pages that were used during the specified period. Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getExitPageTitles","uniqueId":"Actions_getExitPageTitles"},{"category":"Actions","name":"Outlinks","module":"Actions","action":"getOutlinks","dimension":"Clicked URL","metrics":{"nb_visits":"Unique Clicks","nb_hits":"Clicks"},"metricsDocumentation":{"nb_visits":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_hits":"The number of times this link was clicked."},"documentation":"This report shows a hierarchical list of outlink URLs that were clicked by your visitors. An outlink is a link that leads the visitor away from your website (to another domain).<br \/>Use the plus and minus icons on the left to navigate.","actionToLoadSubTables":"getOutlinks","uniqueId":"Actions_getOutlinks"},{"category":"Actions","name":"Downloads","module":"Actions","action":"getDownloads","dimension":"Download URL","metrics":{"nb_visits":"Unique Downloads","nb_hits":"Downloads"},"metricsDocumentation":{"nb_visits":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_hits":"The number of times this link was clicked."},"documentation":"In this report, you can see which files your visitors have downloaded. <br \/> What Piwik counts as a download is the click on a download link. Whether the download was completed or not isn't known to Piwik.","actionToLoadSubTables":"getDownloads","uniqueId":"Actions_getDownloads"},{"category":"Referrers","name":"Referrer Type","module":"Referers","action":"getRefererType","dimension":"Referrer Type","constantRowsCount":true,"documentation":"This table contains information about the distribution of the referrer types.<br \/><b>Direct Entry:<\/b> A visitor has entered the URL in his browser and started browsing on your website - he entered the website directly.<br \/><b>Search Engines:<\/b> A visitor was referred to your website by a search engine. <br \/> See the &quot;Search Engines & Keywords&quot; report for more details.<br \/><b>Websites:<\/b> The visitor followed a link on antoher website that led to your site. <br \/> See the &quot;Websites & Social&quot; report for more details.<br \/><b>Campaigns:<\/b> Visitors that came to your website as the result of a campaign. <br \/> See the &quot;Campaigns&quot; report for more details.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"Referers_getRefererType"},{"category":"Referrers","name":"All Referrers","module":"Referers","action":"getAll","dimension":"Referrer","documentation":"This report shows all your Referers in one unified report, listing all Websites, Search keywords and Campaigns used by your visitors to find your website.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"Referers_getAll"},{"category":"Referrers","name":"Keywords","module":"Referers","action":"getKeywords","actionToLoadSubTables":"getSearchEnginesFromKeywordId","dimension":"Keyword","documentation":"This report shows which keywords users were searching for before they were referred to your website. <br \/> By clicking on a row in the table, you can see the distribution of search engines that were queried for the keyword.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"Referers_getKeywords"},{"category":"Referrers","name":"Websites","module":"Referers","action":"getWebsites","dimension":"Website","documentation":"In this table, you can see which websites referred visitors to your site. <br \/> By clicking on a row in the table, you can see which URLs the links to your website were on.","actionToLoadSubTables":"getUrlsFromWebsiteId","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"Referers_getWebsites"},{"category":"Referrers","name":"Search Engines","module":"Referers","action":"getSearchEngines","dimension":"Search Engine","documentation":"This report shows which search engines referred users to your website. <br \/> By clicking on a row in the table, you can see what users were searching for using a specific search engine.","actionToLoadSubTables":"getKeywordsFromSearchEngineId","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"Referers_getSearchEngines"},{"category":"Referrers","name":"Campaigns","module":"Referers","action":"getCampaigns","dimension":"Campaign","documentation":"This report shows which campaigns led visitors to your website. <br \/> For more information about tracking campaigns, read the <a href=\"http:\/\/piwik.org\/docs\/tracking-campaigns\/\" target=\"_blank\">campaigns documentation on piwik.org<\/a>","actionToLoadSubTables":"getKeywordsFromCampaignId","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"Referers_getCampaigns"},{"category":"Referrers","name":"Social Networks","module":"Referers","action":"getSocials","actionToLoadSubTables":"getUrlsForSocial","dimension":"Social network","documentation":"In this table, you can see which websites referred visitors to your site. <br \/> By clicking on a row in the table, you can see which URLs the links to your website were on.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"Referers_getSocials"},{"category":"Goals","name":"Goals","module":"Goals","action":"get","metrics":{"nb_conversions":"Conversions","nb_visits_converted":"Visits with Conversions","conversion_rate":"Conversion Rate","revenue":"Revenue"},"uniqueId":"Goals_get"},{"category":"Visitors","name":"Country","module":"UserCountry","action":"getCountry","dimension":"Country","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"UserCountry_getCountry"},{"category":"Visitors","name":"Continent","module":"UserCountry","action":"getContinent","dimension":"Continent","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"UserCountry_getContinent"},{"category":"Visitors","name":"Region","module":"UserCountry","action":"getRegion","dimension":"Region","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"UserCountry_getRegion"},{"category":"Visitors","name":"City","module":"UserCountry","action":"getCity","dimension":"City","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"UserCountry_getCity"},{"category":"Visitors","name":"Custom Variables","module":"CustomVariables","action":"getCustomVariables","actionToLoadSubTables":"getCustomVariablesValuesFromNameId","dimension":"Custom Variable name","documentation":"This report contains information about your Custom Variables. Click on a variable name to see the distribution of the values. <br \/> For more information about Custom Variables in general, read the <a href=\"http:\/\/piwik.org\/docs\/custom-variables\/\" target=\"_blank\">Custom Variables documentation on piwik.org<\/a>","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"metricsGoal":{"nb_conversions":"Conversions","revenue":"Revenue"},"processedMetricsGoal":{"revenue_per_visit":"Revenue per Visit"},"uniqueId":"CustomVariables_getCustomVariables"},{"category":"Visitors","name":"Length of Visits","module":"VisitorInterest","action":"getNumberOfVisitsPerVisitDuration","dimension":"Visit duration","metrics":{"nb_visits":"Visits"},"constantRowsCount":true,"documentation":"In this report, you can see how many visits had a certain total duration. Initially, the report is shown as a tag cloud, more common durations are displayed in a larger font.<br \/>Please note, that you can view the report in other ways than as a tag cloud. Use the controls at the bottom of the report to do so.","metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitorInterest_getNumberOfVisitsPerVisitDuration"},{"category":"Visitors","name":"Pages per Visit","module":"VisitorInterest","action":"getNumberOfVisitsPerPage","dimension":"Pages per visit","metrics":{"nb_visits":"Visits"},"constantRowsCount":true,"documentation":"In this report, you can see how many visits involved a certain number of pageviews. Initially, the report is shown as a tag cloud, more common numbers of pages are displayed in a larger font.<br \/>Please note, that you can view the report in other ways than as a tag cloud. Use the controls at the bottom of the report to do so.","metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitorInterest_getNumberOfVisitsPerPage"},{"category":"Visitors","name":"Visits by Visit Number","module":"VisitorInterest","action":"getNumberOfVisitsByVisitCount","dimension":"Visits by Visit Number","metrics":{"nb_visits":"Visits","nb_visits_percentage":"% Visits"},"constantRowsCount":true,"documentation":"In this report, you can see the number of visits who were the Nth visit, ie. visitors who visited your website at least N times.<br \/>Please note, that you can view the report in other ways than as a tag cloud. Use the controls at the bottom of the report to do so.","metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitorInterest_getNumberOfVisitsByVisitCount"},{"category":"Visitors","name":"Visits by days since last visit","module":"VisitorInterest","action":"getNumberOfVisitsByDaysSinceLast","dimension":"Visits by days since last visit","metrics":{"nb_visits":"Visits"},"constantRowsCount":true,"documentation":"In this report, you can see how many visits were from visitors whose last visit was a certain number of days ago.","metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitorInterest_getNumberOfVisitsByDaysSinceLast"},{"category":"Visitors","name":"Returning Visits","module":"VisitFrequency","action":"get","metrics":{"nb_visits_returning":"Returning Visits","nb_actions_returning":"Actions by Returning Visits","avg_time_on_site_returning":"Avg. Duration of a Returning Visit (in sec)","bounce_rate_returning":"Bounce Rate for Returning Visits","nb_actions_per_visit_returning":"Avg. Actions per Returning Visit","nb_uniq_visitors_returning":"Unique returning visitors"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitFrequency_get"},{"category":"Visitors","name":"Provider","module":"Provider","action":"getProvider","dimension":"Provider","documentation":"This report shows which Internet Service Providers your visitors used to access the website. You can click on a provider name for more details. <br \/> If Piwik can't determine a visitor's provider, it is listed as IP.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"Provider_getProvider"},{"category":"Visitor Devices","name":"Device type","module":"DevicesDetection","action":"getType","dimension":"Device type","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getType"},{"category":"Visitor Devices","name":"Device brand","module":"DevicesDetection","action":"getBrand","dimension":"Device brand","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getBrand"},{"category":"Visitor Devices","name":"Device model","module":"DevicesDetection","action":"getModel","dimension":"Device model","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getModel"},{"category":"Visitor Devices","name":"Operating System families","module":"DevicesDetection","action":"getOsFamilies","dimension":"Operating System families","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getOsFamilies"},{"category":"Visitor Devices","name":"Operating System versions","module":"DevicesDetection","action":"getOsVersions","dimension":"Operating System versions","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getOsVersions"},{"category":"Visitor Devices","name":"Browsers families","module":"DevicesDetection","action":"getBrowserFamilies","dimension":"Browsers families","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getBrowserFamilies"},{"category":"Visitor Devices","name":"Browser versions","module":"DevicesDetection","action":"getBrowserVersions","dimension":"Browser versions","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"DevicesDetection_getBrowserVersions"},{"category":"Visitor Settings","name":"Screen Resolution","module":"UserSettings","action":"getResolution","dimension":"Resolution","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getResolution"},{"category":"Visitor Settings","name":"Visitor Browser","module":"UserSettings","action":"getBrowser","dimension":"Browser","documentation":"This report contains information about what kind of browser your visitors were using. Each browser version is listed separately.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getBrowser"},{"category":"Visitor Settings","name":"Browser Version","module":"UserSettings","action":"getBrowserVersion","dimension":"Browser version","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getBrowserVersion"},{"category":"Visitor Settings","name":"Browser Family","module":"UserSettings","action":"getBrowserType","dimension":"Browser family","documentation":"This chart shows your visitors' browsers broken down into browser families. <br \/> The most important information for web developers is what kind of rendering engine their visitors are using. The labels contain the names of the engines followed by the most common browser using that engine in brackets.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getBrowserType"},{"category":"Visitor Settings","name":"Browser Plugins","module":"UserSettings","action":"getPlugin","dimension":"Plugin","documentation":"This report shows which browser plugins your visitors had enabled. This information might be important for choosing the right way to deliver your content.","metrics":{"nb_visits":"Visits","nb_visits_percentage":"% Visits"},"constantRowsCount":true,"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getPlugin"},{"category":"Visitor Settings","name":"Normal \/ Widescreen","module":"UserSettings","action":"getWideScreen","dimension":"Type of screen","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getWideScreen"},{"category":"Visitor Settings","name":"Operating System","module":"UserSettings","action":"getOS","dimension":"Operating system","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getOS"},{"category":"Visitor Settings","name":"Visitor Configuration","module":"UserSettings","action":"getConfiguration","dimension":"Configuration","documentation":"This report shows the most common overall configurations that your visitors had. A configuration is the combination of an operating system, a browser type and a screen resolution.","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getConfiguration"},{"category":"Visitor Settings","name":"Operating System Family","module":"UserSettings","action":"getOSFamily","dimension":"Operating system family","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getOSFamily"},{"category":"Visitor Settings","name":"Mobile vs Desktop","module":"UserSettings","action":"getMobileVsDesktop","dimension":"Mobile vs Desktop","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getMobileVsDesktop"},{"category":"Visitor Settings","name":"Browser language","module":"UserSettings","action":"getLanguage","dimension":"Language","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getLanguage"},{"category":"API","name":"Main metrics","module":"API","action":"get","metrics":{"nb_uniq_visitors":"Unique visitors","nb_visits":"Visits","nb_actions":"Actions","nb_actions_per_visit":"Actions per Visit","bounce_rate":"Bounce Rate","avg_time_on_site":"Avg. Visit Duration (in seconds)","max_actions":"Maximum actions in one visit","nb_pageviews":"Pageviews","nb_uniq_pageviews":"Unique Pageviews","nb_downloads":"Downloads","nb_uniq_downloads":"Unique Downloads","nb_outlinks":"Outlinks","nb_uniq_outlinks":"Unique Outlinks","nb_searches":"Searches","nb_keywords":"Unique Keywords","avg_time_generation":"Avg. generation time","nb_conversions":"Conversions","nb_visits_converted":"Visits with Conversions","conversion_rate":"Conversion Rate","revenue":"Revenue","nb_visits_returning":"Returning Visits","nb_actions_returning":"Actions by Returning Visits","avg_time_on_site_returning":"Avg. Duration of a Returning Visit (in sec)","bounce_rate_returning":"Bounce Rate for Returning Visits","nb_actions_per_visit_returning":"Avg. Actions per Returning Visit","nb_uniq_visitors_returning":"Unique returning visitors"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page.","nb_pageviews":"The number of times this page was visited.","nb_uniq_pageviews":"The number of visits that included this page. If a page was viewed multiple times during one visit, it is only counted once.","nb_downloads":"The number of times this link was clicked.","nb_uniq_downloads":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_outlinks":"The number of times this link was clicked.","nb_uniq_outlinks":"The number of visits that involved a click on this link. If a link was clicked multiple times during one visit, it is only counted once.","nb_searches":"The number of visits that searched for this keyword on your website's search engine.","avg_time_generation":"The average time it took to generate the page. This metric includes the time it took the server to generate the web page, plus the time it took for the visitor to download the response from the server. A lower 'Avg. generation time' means a faster website for your visitors!"},"uniqueId":"API_get"}];
};

exports.getMobileVsDesktopReport = function ()
{
    return {"category":"Visitor Settings","name":"Mobile vs Desktop","module":"UserSettings","action":"getMobileVsDesktop","dimension":"Mobile vs Desktop","metrics":{"nb_visits":"Visits","nb_uniq_visitors":"Unique visitors","nb_actions":"Actions"},"processedMetrics":{"nb_actions_per_visit":"Actions per Visit","avg_time_on_site":"Avg. Time on Website","bounce_rate":"Bounce Rate","conversion_rate":"Conversion Rate"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"UserSettings_getMobileVsDesktop"};
};

exports.getVisitsSummaryReport = function () {
    return {"category":"Visits Summary","name":"Visits Summary","module":"VisitsSummary","action":"get","metrics":{"nb_uniq_visitors":"Unique visitors","nb_visits":"Visits","nb_actions":"Actions","nb_actions_per_visit":"Actions per Visit","bounce_rate":"Bounce Rate","avg_time_on_site":"Avg. Visit Duration (in seconds)","max_actions":"Maximum actions in one visit"},"metricsDocumentation":{"nb_visits":"If a visitor comes to your website for the first time or if he visits a page more than 30 minutes after his last page view, this will be recorded as a new visit.","nb_uniq_visitors":"The number of unduplicated visitors coming to your website. Every user is only counted once, even if he visits the website multiple times a day.","nb_actions":"The number of actions performed by your visitors. Actions can be page views, internal site searches, downloads or outlinks.","nb_actions_per_visit":"The average number of actions (page views, site searches, downloads or outlinks) that were performed during the visits.","avg_time_on_site":"The average duration of a visit.","bounce_rate":"The percentage of visits that only had a single pageview. This means, that the visitor left the website directly from the entrance page.","conversion_rate":"The percentage of visits that triggered a goal conversion.","avg_time_on_page":"The average amount of time visitors spent on this page (only the page, not the entire website).","nb_hits":"The number of times this page was visited.","exit_rate":"The percentage of visits that left the website after viewing this page."},"uniqueId":"VisitsSummary_get"};
};

exports.getAGoalReport = function () {
    return {"category":"Goals","name":"Goal Use URL Builder","module":"Goals","action":"get","parameters":{"idGoal":"4"},"metrics":{"nb_conversions":"Conversions","nb_visits_converted":"Visits with Conversions","conversion_rate":"Conversion Rate","revenue":"Revenue"},"imageGraphUrl":"index.php?module=API&method=ImageGraph.get&idSite=1&apiModule=Goals&apiAction=get&token_auth=362f95441d5e7a1a9c5c081e2d173ff5&idGoal=4&period=day&date=2013-06-05,2013-07-04","imageGraphEvolutionUrl":"index.php?module=API&method=ImageGraph.get&idSite=1&apiModule=Goals&apiAction=get&token_auth=362f95441d5e7a1a9c5c081e2d173ff5&idGoal=4&period=day&date=2013-06-05,2013-07-04","uniqueId":"Goals_get_idGoal--4"};
};